<?php
// CONFIG: Enable debug mode. This means we'll log requests into 'ipn.log' in the same directory.
// Especially useful if you encounter network errors or other intermittent problems with IPN (validation).
// Set this to 0 once you go live or don't require logging.
define("DEBUG", 1);
// Set to 0 once you're ready to go live
define("USE_SANDBOX", 1);
define("LOG_FILE", "./ipn.log");
// STEP 1: Read POST data

// reading posted data from directly from $_POST causes serialization 
// issues with array data in POST
// reading raw POST data from input stream instead. 
$raw_post_data = file_get_contents('php://input');
$raw_post_array = explode('&', $raw_post_data);
$myPost = array();
foreach ($raw_post_array as $keyval) {
  $keyval = explode ('=', $keyval);
  if (count($keyval) == 2)
     $myPost[$keyval[0]] = urldecode($keyval[1]);
}
// read the post from PayPal system and add 'cmd'
$req = 'cmd=_notify-validate';
if(function_exists('get_magic_quotes_gpc')) {
   $get_magic_quotes_exists = true;
} 
foreach ($myPost as $key => $value) {        
   if($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) { 
        $value = urlencode(stripslashes($value)); 
   } else {
        $value = urlencode($value);
   }
   $req .= "&$key=$value";
}


// STEP 2: Post IPN data back to paypal to validate.
// Post IPN data back to PayPal to validate the IPN data is genuine
// Without this step anyone can fake IPN data
if(USE_SANDBOX == true) {
$paypal_url = "https://www.sandbox.paypal.com/cgi-bin/webscr";
} else {
$paypal_url = "https://www.paypal.com/cgi-bin/webscr";
}
$ch = curl_init($paypal_url);
if ($ch == FALSE) {
return FALSE;
}
curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));

// In wamp like environments that do not come bundled with root authority certificates,
// please download 'cacert.pem' from "http://curl.haxx.se/docs/caextract.html" and set the directory path 
// of the certificate as shown below.
// curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/cacert.pem');
if( !($res = curl_exec($ch)) ) {
    // error_log("Got " . curl_error($ch) . " when processing IPN data");
    curl_close($ch);
    exit;
}
curl_close($ch);


// STEP 3: Inspect IPN validation result and act accordingly

if (strcmp ($res, "VERIFIED") == 0) {
    // check whether the payment_status is Completed
    // check that txn_id has not been previously processed
    // check that receiver_email is your Primary PayPal email
    // check that payment_amount/payment_currency are correct
    // process payment
    // assign posted variables to local variables
    	
		
//****These are some of the variables that paypal can pass back. Comment out the ones you don't need
    
    $payment_status = $_POST['payment_status'];
    $payment_amount = $_POST['mc_gross'];
    $txn_id = $_POST['txn_id'];
    $receiver_email = $_POST['receiver_email'];
    $payer_email = $_POST['payer_email'];
    $first_name = $_POST['first_name'];
    $last_name = $_POST['last_name'];
	$item_number = $_POST['item_number'];
	$item_name = $_POST['item_name'];
    $subscr_date = $_POST['subscr_date'];
	$subscription_expiredate = date('Y-m-d', strtotime("$subscr_date +360 days") );
    $paypal_pay_date = date('Y-m-d', strtotime("$subscr_date") );
	$first_name = $_POST['first_name'];
	$last_name = $_POST['last_name'];
	//$address_name = $_POST['address_name'];
	//$address_street = $_POST['address_street'];
	//$address_city = $_POST['address_city'];
	//$address_state = $_POST['address_state'];
	//$address_zip = $_POST['address_zip'];
	//$address_country = $_POST['address_country'];
	//$payer_id = $_POST['payer_id'];
	
	//$recurring = $_POST['recurring'];
	//$subscr_id = $_POST['subscr_id'];
    $mc_amount3 = $_POST['mc_amount3'];
	//$trial = $_POST['period1'];
	//$trans_type = $_POST['txn_type'];
    
	if(DEBUG == true) {
     error_log(date('[Y-m-d H:i e] '). "Verified IPN: $req ". PHP_EOL, 3, LOG_FILE);
    } 
	 
	
}

//Now use the set variables to do your needed tasks

//Connecting to a database and changing the values for the subscriber.
// Connection data (server_address, database, name, password)
$hostdb = 'localhost';
$namedb = 'databasename';
$userdb = 'databaseuser';
$passdb = 'password';

try {
  // Connect and create the PDO object
  $conn = new PDO("mysql:host=$hostdb; dbname=$namedb", $userdb, $passdb);
  $conn->exec("SET CHARACTER SET utf8");      // Sets encoding UTF-8
  
  // Changes the item_sold to 1 in the table
  $sql = "UPDATE `tablename` SET `item_sold`='1' WHERE `item_name`='$item_name'";
  $update = $conn->exec($sql);

  $conn = null;        // Disconnect
}
catch(PDOException $e) {
  echo $e->getMessage();
}

// If the query is successfully performed ($update not false)
if($update !== false)

   //Change these to your store name
    $storename = "Bob";
    $email = "bobsstore@toystore.com";
    
	$date = new DateTime('now');
    $date->modify('+2 hours');// Server offset adjust as needed
	$to = $payer_email;
	$subject =  $first_name ." ".$last_name.", thanks for buying '.$item_name.'" ;
                             
$headers = 'From:'.$storename.'\'s Store<'.$email.'>'. "\r\n" .
    'Reply-To:'. $email .  "\r\n" .
    'X-Mailer: PHP/' . phpversion();



$headers .= "MIME-Version: 1.0\r\n";
$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";
	
$message ='<!DOCTYPE html>';
$message .='<html dir="ltr" lang="en">';
$message .='<head><title>You got mail!</title></head>';
$message .='<body style="background-color:#FDFFAD; max-width: 600px; font-family: Helvetica, Arial;">';
$message .='<style type="text/css">';
$message .='body {background-color:#FDFFAD;max-width:600px;font-family: Helvetica, Arial; font-weight:bold;}';
$message .='p{font-size: 12px; color: #666666;}';
$message .='h2{font-size: 28px !important;color: #666666 ! important;margin: 0px; border-bottom: 2px dotted #00A2FF; padding-bottom:3px;}';
$message .='table{width:100%;}';
$message .='td {font-size: 10px !important; line-height: 30px;color: #666666 !important; margin: 0px;}';
$message .='td:first-child {font-size: 10px !important; font-weight:bold; color: #333 !important; vertical-align:text-top; min-width:20%; padding-right:5px;}';
$message .='a:link {color:0000FF; text-decoration:underline;} a:visited {color:FF0080; text-decoration:none;} a:hover {color:#00A2FF;}';
$message .='b{font-weight: bold;}';
$message .='tr.top td { border-top: 3px solid black; }';
$message .='tr.bottom td { border-bottom:  3px solid black; }';
$message .='tr.left td { border-left: 3px solid black; }';
$message .='tr.right td { border-right: 3px solid black; }';
$message .='tr.row td:first-child { border-left:  3px solid black; }';
$message .='tr.row td:last-child { border-right:  3px solid black; }';
$message .='tr{background: rgb(255,255,255,);background: rgba(255,255,255, .5);} ';
$message .='</style>';
$message .='<div>';
$message .='<table id="email_table" width="100%"  cellspacing="0" cellpadding="4">';

$message .='<tr class="top left right"><td valign="top" style="background:#620000 url(http://mysite.com/paypal/images/banner_email_300.png) no-repeat bottom;height:60px; max-width:490px; border-bottom:none;"></td></tr>';
$message .='<tr  class="bottom left right" style="background:#620000;"><td><font color="#FFFFFF">Here\'s your Paypal payment info</font></td></tr>';
$message .='<tr class="left right"><td><font color="#008040"> Date: </font> ' . $date->format('l jS \of F Y h:i:s A') . '</td></tr>';
$message .='<tr class="left right"><td></td></tr>';
$message .='<tr class="top left right"><td>First Name: '.$first_name.'</td></tr>';
$message .='<tr class="top left right"><td>Last Name: '.$last_name.'</td></tr>';
$message .='<tr class="top left right"><td>Email: '.$email.'</td></tr>'; 
$message .='<tr class="top left right"><td>Paypal Payment date: '.$paypal_pay_date.'</td></tr>';
$message .='<tr class="top left right"><td>Item Name: '.$item_name.'</td></tr>';
$message .='<tr class="top left right"><td>Payment amount: $'.$mc_amount3.'</td></tr>';
$message .='<tr class="top bottom left right"><td style="background:#620000 url(http://mysite.com/paypal/images/nav.png) no-repeat right;"><font color="#FFFFFF"><a href="http://mysite.com">Mysite.com</a></font></td></tr>';

$message .='</table>';
$message .='</div>';
$message .='</body>';
$message .='</html>';
	mail($to, $subject, $message, $headers);
	



}
 else if (strcmp ($res, "INVALID") == 0) {
    // log for manual investigation
		// log for manual investigation
// Add business logic here which deals with invalid IPN messages
if(DEBUG == true) {
error_log(date('[Y-m-d H:i e] '). "Invalid IPN: $req" . PHP_EOL, 3, LOG_FILE);
}
}
?>